/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB® Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB® Code Configurator - v2.25.2
        Device            :  PIC24FJ256GB106
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC16 v1.24
        MPLAB             :  MPLAB X v2.35 or v3.00
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#include "mcc_generated_files/mcc.h"
#include "APP026-3_LCM.h"
#include <stdio.h>

volatile unsigned char T1Flag = 0;
volatile unsigned char T2Flag = 0;
volatile unsigned char AD1Flag = 0;
volatile unsigned int AD1Buffer[2];
unsigned char UARTString[100];
unsigned char Cursor = 12;

void UART_PutRAMString(unsigned char * String);

/*
                         Main application
 */
int main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // LCM初始化。
    LCM_Init();

    // 設定遊標，輸出字串。
    LCM_SetCursor(0, 0);
    LCM_PutROMString((unsigned char *) "PIC24FJ256GB106 ");
    LCM_SetCursor(0, 1);
    LCM_PutROMString((unsigned char *) "VR1:    ,RX:    ");

    while (1)
    {
        // Add your application code
        if (T1Flag)
        {
            T1Flag = 0;
            D4_Toggle();
            D5_Toggle();
        }

        if (T2Flag)
        {
            T2Flag = 0;
            LED3_Toggle();
            LED4_Toggle();

            if (AD1Flag)
            {
                AD1Flag = 0;
                LCM_SetCursor(4, 1);
                LCM_PutNumber(AD1Buffer[0], 4);

                sprintf((char *) UARTString, "VR1 Value : %4d, VR2 Value : %4d\r\n",
                        AD1Buffer[0], AD1Buffer[1]);

                UART_PutRAMString(UARTString);

                if (AD1Buffer[0] >= 1023)
                    OC1_EdgeAlignedPWMConfig(????, OC1RS);
                else
                    OC1_EdgeAlignedPWMConfig((long) AD1Buffer[0] * ????, OC1RS);

            }
        }

        if (!UART2_ReceiveBufferIsEmpty())
        {
            LCM_SetCursor(Cursor++, 1);
            LCM_PutASCII(UART2_Read());

            if (Cursor > 15) Cursor = 12;
        }
    }

    while (1);
}

void UART_PutRAMString(unsigned char * String)
{
    while (*String != 0x00)
    {
        while (U2STAbits.UTXBF);
        U2TXREG = *String++;
    }
}
/**
 End of File
 */